#!/usr/bin/env python

#****************************************************************************
# icondict.py, provides a class to load and store tree icons
#
# TreeLine, an information storage program
# Copyright (C) 2005, Douglas W. Bell
#
# This is free software; you can redistribute it and/or modify it under the
# terms of the GNU General Public License, Version 2.  This program is
# distributed in the hope that it will be useful, but WITTHOUT ANY WARRANTY.
#*****************************************************************************

import globalref, xpm
from qt import QPixmap

class IconDict(dict):
    """Loads and stores tree icons by name"""
    defaultName = 'default'
    noneName = 'NoIcon'
    def __init__(self, initDict={}):
        dict.__init__(self, initDict)
        self[IconDict.noneName] = None

    def loadStandardIcons(self):
        """Load XPM-format icons from list in xpm.py"""
        for name in xpm.treeIconList:
            self[name] = QPixmap(eval('xpm.%s' % name))

    def getIcon(self, name):
        """Return an icon matching name or the default icon"""
        try:
            return self[name]
        except KeyError:
            return self[IconDict.defaultName]
